import{S as mi,i as pi,s as ui,e as r,k as h,w as kt,t as o,M as _i,c as i,d as a,m as f,a as n,x as Rt,h as l,b as c,P as vi,G as e,g as d,y as Pt,L as gi,q as xt,o as Tt,B as Ct,v as wi}from"../../chunks/vendor-hf-doc-builder.js";import{I as $t}from"../../chunks/IconCopyLink-hf-doc-builder.js";function yi(Ql){let L,Dt,A,C,Ee,X,Ea,Le,La,Ot,$,Aa,Y,ka,Ra,It,D,Pa,Ae,xa,Ta,Mt,ne,Ca,St,v,ke,$a,Da,Re,Oa,Ia,Pe,Ma,Sa,xe,Ua,Na,Te,qa,Ut,O,Fa,Ce,za,Wa,Nt,k,I,$e,Z,Ba,De,Ha,qt,M,ja,se,Ga,Ja,Ft,ee,Oe,Xl,zt,b,Va,Ie,Ka,Qa,Me,Xa,Ya,Wt,R,S,Se,te,Za,Ue,eo,Bt,U,to,Ne,ao,oo,Ht,N,lo,qe,ro,io,jt,q,no,de,so,ho,Gt,F,fo,he,co,mo,Jt,z,po,fe,uo,_o,Vt,P,W,Fe,ae,vo,ze,go,Kt,ce,wo,Qt,w,We,yo,bo,oe,Eo,Be,Lo,Ao,ko,x,Ro,He,Po,xo,je,To,Co,$o,le,Do,Ge,Oo,Io,Xt,re,Je,Mo,So,Yt,m,B,Ve,Uo,No,Ke,qo,Fo,zo,me,Qe,Wo,Bo,Ho,pe,Xe,jo,Go,Jo,g,Ye,Vo,Ko,Ze,Qo,Xo,et,Yo,Zo,tt,el,tl,at,al,ol,ll,ue,ot,rl,il,nl,H,lt,sl,dl,rt,hl,fl,cl,p,it,ml,pl,nt,ul,_l,st,vl,gl,dt,wl,yl,ht,bl,El,ft,Ll,Al,ct,kl,Rl,Pl,j,mt,xl,Tl,pt,Cl,$l,Dl,G,ut,Ol,Il,_t,Ml,Sl,Zt,T,J,vt,ie,Ul,gt,Nl,ea,_e,ql,ta,V,wt,ve,Fl,zl,yt,ge,Wl,aa,K,Bl,we,Hl,jl,oa;return X=new $t({}),Z=new $t({}),te=new $t({}),ae=new $t({}),ie=new $t({}),{c(){L=r("meta"),Dt=h(),A=r("h1"),C=r("a"),Ee=r("span"),kt(X.$$.fragment),Ea=h(),Le=r("span"),La=o("LoRA"),Ot=h(),$=r("p"),Aa=o("This conceptual guide gives a brief overview of "),Y=r("a"),ka=o("LoRA"),Ra=o(`, a technique that accelerates
the fine-tuning of large models while consuming less memory.`),It=h(),D=r("p"),Pa=o(`To make fine-tuning more efficient, LoRA\u2019s approach is to represent the weight updates with two smaller
matrices (called `),Ae=r("strong"),xa=o("update matrices"),Ta=o(`) through low-rank decomposition. These new matrices can be trained to adapt to the
new data while keeping the overall number of changes low. The original weight matrix remains frozen and doesn\u2019t receive
any further adjustments. To produce the final results, both the original and the adapted weights are combined.`),Mt=h(),ne=r("p"),Ca=o("This approach has a number of advantages:"),St=h(),v=r("ul"),ke=r("li"),$a=o("LoRA makes fine-tuning more efficient by drastically reducing the number of trainable parameters."),Da=h(),Re=r("li"),Oa=o("The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable LoRA models for various downstream tasks built on top of them."),Ia=h(),Pe=r("li"),Ma=o("LoRA is orthogonal to many other parameter-efficient methods and can be combined with many of them."),Sa=h(),xe=r("li"),Ua=o("Performance of models fine-tuned using LoRA is comparable to the performance of fully fine-tuned models."),Na=h(),Te=r("li"),qa=o("LoRA does not add any inference latency because adapter weights can be merged with the base model."),Ut=h(),O=r("p"),Fa=o(`In principle, LoRA can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. However, for simplicity and further parameter efficiency, in Transformer models LoRA is typically applied to
attention blocks only. The resulting number of trainable parameters in a LoRA model depends on the size of the low-rank
update matrices, which is determined mainly by the rank `),Ce=r("code"),za=o("r"),Wa=o(" and the shape of the original weight matrix."),Nt=h(),k=r("h2"),I=r("a"),$e=r("span"),kt(Z.$$.fragment),Ba=h(),De=r("span"),Ha=o("Merge LoRA weights into the base model"),qt=h(),M=r("p"),ja=o("While LoRA is significantly smaller and faster to train, you may encounter latency issues during inference due to separately loading the base model and the LoRA model. To eliminate latency, use the "),se=r("a"),Ga=o("merge_and_unload()"),Ja=o(" function to merge the adapter weights with the base model which allows you to effectively use the newly merged model as a standalone model."),Ft=h(),ee=r("div"),Oe=r("img"),zt=h(),b=r("p"),Va=o("This works because during training, the smaller weight matrices ("),Ie=r("em"),Ka=o("A"),Qa=o(" and "),Me=r("em"),Xa=o("B"),Ya=o(" in the diagram above) are separate. But once training is complete, the weights can actually be merged into a new weight matrix that is identical."),Wt=h(),R=r("h2"),S=r("a"),Se=r("span"),kt(te.$$.fragment),Za=h(),Ue=r("span"),eo=o("Utils for LoRA"),Bt=h(),U=r("p"),to=o("Use "),Ne=r("code"),ao=o("merge_adapter()"),oo=o(` to merge the LoRa layers into the base model while retaining the PeftModel.
This will help in later unmerging, deleting, loading different adapters and so on.`),Ht=h(),N=r("p"),lo=o("Use "),qe=r("code"),ro=o("unmerge_adapter()"),io=o(` to unmerge the LoRa layers from the base model while retaining the PeftModel.
This will help in later merging, deleting, loading different adapters and so on.`),jt=h(),q=r("p"),no=o("Use "),de=r("a"),so=o("unload()"),ho=o(` to get back the base model without the merging of the active lora modules.
This will help when you want to get back the pretrained base model in some applications when you want to reset the model to its original state.
For example, in Stable Diffusion WebUi, when the user wants to infer with base model post trying out LoRAs.`),Gt=h(),F=r("p"),fo=o("Use "),he=r("a"),co=o("delete_adapter()"),mo=o(" to delete an existing adapter."),Jt=h(),z=r("p"),po=o("Use "),fe=r("a"),uo=o("add_weighted_adapter()"),_o=o(" to combine multiple LoRAs into a new adapter based on the user provided weighing scheme."),Vt=h(),P=r("h2"),W=r("a"),Fe=r("span"),kt(ae.$$.fragment),vo=h(),ze=r("span"),go=o("Common LoRA parameters in PEFT"),Kt=h(),ce=r("p"),wo=o("As with other methods supported by PEFT, to fine-tune a model using LoRA, you need to:"),Qt=h(),w=r("ol"),We=r("li"),yo=o("Instantiate a base model."),bo=h(),oe=r("li"),Eo=o("Create a configuration ("),Be=r("code"),Lo=o("LoraConfig"),Ao=o(") where you define LoRA-specific parameters."),ko=h(),x=r("li"),Ro=o("Wrap the base model with "),He=r("code"),Po=o("get_peft_model()"),xo=o(" to get a trainable "),je=r("code"),To=o("PeftModel"),Co=o("."),$o=h(),le=r("li"),Do=o("Train the "),Ge=r("code"),Oo=o("PeftModel"),Io=o(" as you normally would train the base model."),Xt=h(),re=r("p"),Je=r("code"),Mo=o("LoraConfig"),So=o(" allows you to control how LoRA is applied to the base model through the following parameters:"),Yt=h(),m=r("ul"),B=r("li"),Ve=r("code"),Uo=o("r"),No=o(": the rank of the update matrices, expressed in "),Ke=r("code"),qo=o("int"),Fo=o(". Lower rank results in smaller update matrices with fewer trainable parameters."),zo=h(),me=r("li"),Qe=r("code"),Wo=o("target_modules"),Bo=o(": The modules (for example, attention blocks) to apply the LoRA update matrices."),Ho=h(),pe=r("li"),Xe=r("code"),jo=o("alpha"),Go=o(": LoRA scaling factor."),Jo=h(),g=r("li"),Ye=r("code"),Vo=o("bias"),Ko=o(": Specifies if the "),Ze=r("code"),Qo=o("bias"),Xo=o(" parameters should be trained. Can be "),et=r("code"),Yo=o("'none'"),Zo=o(", "),tt=r("code"),el=o("'all'"),tl=o(" or "),at=r("code"),al=o("'lora_only'"),ol=o("."),ll=h(),ue=r("li"),ot=r("code"),rl=o("modules_to_save"),il=o(": List of modules apart from LoRA layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),nl=h(),H=r("li"),lt=r("code"),sl=o("layers_to_transform"),dl=o(": List of layers to be transformed by LoRA. If not specified, all layers in "),rt=r("code"),hl=o("target_modules"),fl=o(" are transformed."),cl=h(),p=r("li"),it=r("code"),ml=o("layers_pattern"),pl=o(": Pattern to match layer names in "),nt=r("code"),ul=o("target_modules"),_l=o(", if "),st=r("code"),vl=o("layers_to_transform"),gl=o(" is specified. By default "),dt=r("code"),wl=o("PeftModel"),yl=o(" will look at common layer pattern ("),ht=r("code"),bl=o("layers"),El=o(", "),ft=r("code"),Ll=o("h"),Al=o(", "),ct=r("code"),kl=o("blocks"),Rl=o(", etc.), use it for exotic and custom models."),Pl=h(),j=r("li"),mt=r("code"),xl=o("rank_pattern"),Tl=o(": The mapping from layer names or regexp expression to ranks which are different from the default rank specified by "),pt=r("code"),Cl=o("r"),$l=o("."),Dl=h(),G=r("li"),ut=r("code"),Ol=o("alpha_pattern"),Il=o(": The mapping from layer names or regexp expression to alphas which are different from the default alpha specified by "),_t=r("code"),Ml=o("lora_alpha"),Sl=o("."),Zt=h(),T=r("h2"),J=r("a"),vt=r("span"),kt(ie.$$.fragment),Ul=h(),gt=r("span"),Nl=o("LoRA examples"),ea=h(),_e=r("p"),ql=o("For an example of LoRA method application to various downstream tasks, please refer to the following guides:"),ta=h(),V=r("ul"),wt=r("li"),ve=r("a"),Fl=o("Image classification using LoRA"),zl=h(),yt=r("li"),ge=r("a"),Wl=o("Semantic segmentation"),aa=h(),K=r("p"),Bl=o(`While the original paper focuses on language models, the technique can be applied to any dense layers in deep learning
models. As such, you can leverage this technique with diffusion models. See `),we=r("a"),Hl=o("Dreambooth fine-tuning with LoRA"),jl=o(" task guide for an example."),this.h()},l(t){const s=_i('[data-svelte="svelte-1phssyn"]',document.head);L=i(s,"META",{name:!0,content:!0}),s.forEach(a),Dt=f(t),A=i(t,"H1",{class:!0});var la=n(A);C=i(la,"A",{id:!0,class:!0,href:!0});var Yl=n(C);Ee=i(Yl,"SPAN",{});var Zl=n(Ee);Rt(X.$$.fragment,Zl),Zl.forEach(a),Yl.forEach(a),Ea=f(la),Le=i(la,"SPAN",{});var er=n(Le);La=l(er,"LoRA"),er.forEach(a),la.forEach(a),Ot=f(t),$=i(t,"P",{});var ra=n($);Aa=l(ra,"This conceptual guide gives a brief overview of "),Y=i(ra,"A",{href:!0,rel:!0});var tr=n(Y);ka=l(tr,"LoRA"),tr.forEach(a),Ra=l(ra,`, a technique that accelerates
the fine-tuning of large models while consuming less memory.`),ra.forEach(a),It=f(t),D=i(t,"P",{});var ia=n(D);Pa=l(ia,`To make fine-tuning more efficient, LoRA\u2019s approach is to represent the weight updates with two smaller
matrices (called `),Ae=i(ia,"STRONG",{});var ar=n(Ae);xa=l(ar,"update matrices"),ar.forEach(a),Ta=l(ia,`) through low-rank decomposition. These new matrices can be trained to adapt to the
new data while keeping the overall number of changes low. The original weight matrix remains frozen and doesn\u2019t receive
any further adjustments. To produce the final results, both the original and the adapted weights are combined.`),ia.forEach(a),Mt=f(t),ne=i(t,"P",{});var or=n(ne);Ca=l(or,"This approach has a number of advantages:"),or.forEach(a),St=f(t),v=i(t,"UL",{});var E=n(v);ke=i(E,"LI",{});var lr=n(ke);$a=l(lr,"LoRA makes fine-tuning more efficient by drastically reducing the number of trainable parameters."),lr.forEach(a),Da=f(E),Re=i(E,"LI",{});var rr=n(Re);Oa=l(rr,"The original pre-trained weights are kept frozen, which means you can have multiple lightweight and portable LoRA models for various downstream tasks built on top of them."),rr.forEach(a),Ia=f(E),Pe=i(E,"LI",{});var ir=n(Pe);Ma=l(ir,"LoRA is orthogonal to many other parameter-efficient methods and can be combined with many of them."),ir.forEach(a),Sa=f(E),xe=i(E,"LI",{});var nr=n(xe);Ua=l(nr,"Performance of models fine-tuned using LoRA is comparable to the performance of fully fine-tuned models."),nr.forEach(a),Na=f(E),Te=i(E,"LI",{});var sr=n(Te);qa=l(sr,"LoRA does not add any inference latency because adapter weights can be merged with the base model."),sr.forEach(a),E.forEach(a),Ut=f(t),O=i(t,"P",{});var na=n(O);Fa=l(na,`In principle, LoRA can be applied to any subset of weight matrices in a neural network to reduce the number of trainable
parameters. However, for simplicity and further parameter efficiency, in Transformer models LoRA is typically applied to
attention blocks only. The resulting number of trainable parameters in a LoRA model depends on the size of the low-rank
update matrices, which is determined mainly by the rank `),Ce=i(na,"CODE",{});var dr=n(Ce);za=l(dr,"r"),dr.forEach(a),Wa=l(na," and the shape of the original weight matrix."),na.forEach(a),Nt=f(t),k=i(t,"H2",{class:!0});var sa=n(k);I=i(sa,"A",{id:!0,class:!0,href:!0});var hr=n(I);$e=i(hr,"SPAN",{});var fr=n($e);Rt(Z.$$.fragment,fr),fr.forEach(a),hr.forEach(a),Ba=f(sa),De=i(sa,"SPAN",{});var cr=n(De);Ha=l(cr,"Merge LoRA weights into the base model"),cr.forEach(a),sa.forEach(a),qt=f(t),M=i(t,"P",{});var da=n(M);ja=l(da,"While LoRA is significantly smaller and faster to train, you may encounter latency issues during inference due to separately loading the base model and the LoRA model. To eliminate latency, use the "),se=i(da,"A",{href:!0});var mr=n(se);Ga=l(mr,"merge_and_unload()"),mr.forEach(a),Ja=l(da," function to merge the adapter weights with the base model which allows you to effectively use the newly merged model as a standalone model."),da.forEach(a),Ft=f(t),ee=i(t,"DIV",{class:!0});var pr=n(ee);Oe=i(pr,"IMG",{src:!0}),pr.forEach(a),zt=f(t),b=i(t,"P",{});var ye=n(b);Va=l(ye,"This works because during training, the smaller weight matrices ("),Ie=i(ye,"EM",{});var ur=n(Ie);Ka=l(ur,"A"),ur.forEach(a),Qa=l(ye," and "),Me=i(ye,"EM",{});var _r=n(Me);Xa=l(_r,"B"),_r.forEach(a),Ya=l(ye," in the diagram above) are separate. But once training is complete, the weights can actually be merged into a new weight matrix that is identical."),ye.forEach(a),Wt=f(t),R=i(t,"H2",{class:!0});var ha=n(R);S=i(ha,"A",{id:!0,class:!0,href:!0});var vr=n(S);Se=i(vr,"SPAN",{});var gr=n(Se);Rt(te.$$.fragment,gr),gr.forEach(a),vr.forEach(a),Za=f(ha),Ue=i(ha,"SPAN",{});var wr=n(Ue);eo=l(wr,"Utils for LoRA"),wr.forEach(a),ha.forEach(a),Bt=f(t),U=i(t,"P",{});var fa=n(U);to=l(fa,"Use "),Ne=i(fa,"CODE",{});var yr=n(Ne);ao=l(yr,"merge_adapter()"),yr.forEach(a),oo=l(fa,` to merge the LoRa layers into the base model while retaining the PeftModel.
This will help in later unmerging, deleting, loading different adapters and so on.`),fa.forEach(a),Ht=f(t),N=i(t,"P",{});var ca=n(N);lo=l(ca,"Use "),qe=i(ca,"CODE",{});var br=n(qe);ro=l(br,"unmerge_adapter()"),br.forEach(a),io=l(ca,` to unmerge the LoRa layers from the base model while retaining the PeftModel.
This will help in later merging, deleting, loading different adapters and so on.`),ca.forEach(a),jt=f(t),q=i(t,"P",{});var ma=n(q);no=l(ma,"Use "),de=i(ma,"A",{href:!0});var Er=n(de);so=l(Er,"unload()"),Er.forEach(a),ho=l(ma,` to get back the base model without the merging of the active lora modules.
This will help when you want to get back the pretrained base model in some applications when you want to reset the model to its original state.
For example, in Stable Diffusion WebUi, when the user wants to infer with base model post trying out LoRAs.`),ma.forEach(a),Gt=f(t),F=i(t,"P",{});var pa=n(F);fo=l(pa,"Use "),he=i(pa,"A",{href:!0});var Lr=n(he);co=l(Lr,"delete_adapter()"),Lr.forEach(a),mo=l(pa," to delete an existing adapter."),pa.forEach(a),Jt=f(t),z=i(t,"P",{});var ua=n(z);po=l(ua,"Use "),fe=i(ua,"A",{href:!0});var Ar=n(fe);uo=l(Ar,"add_weighted_adapter()"),Ar.forEach(a),_o=l(ua," to combine multiple LoRAs into a new adapter based on the user provided weighing scheme."),ua.forEach(a),Vt=f(t),P=i(t,"H2",{class:!0});var _a=n(P);W=i(_a,"A",{id:!0,class:!0,href:!0});var kr=n(W);Fe=i(kr,"SPAN",{});var Rr=n(Fe);Rt(ae.$$.fragment,Rr),Rr.forEach(a),kr.forEach(a),vo=f(_a),ze=i(_a,"SPAN",{});var Pr=n(ze);go=l(Pr,"Common LoRA parameters in PEFT"),Pr.forEach(a),_a.forEach(a),Kt=f(t),ce=i(t,"P",{});var xr=n(ce);wo=l(xr,"As with other methods supported by PEFT, to fine-tune a model using LoRA, you need to:"),xr.forEach(a),Qt=f(t),w=i(t,"OL",{});var Q=n(w);We=i(Q,"LI",{});var Tr=n(We);yo=l(Tr,"Instantiate a base model."),Tr.forEach(a),bo=f(Q),oe=i(Q,"LI",{});var va=n(oe);Eo=l(va,"Create a configuration ("),Be=i(va,"CODE",{});var Cr=n(Be);Lo=l(Cr,"LoraConfig"),Cr.forEach(a),Ao=l(va,") where you define LoRA-specific parameters."),va.forEach(a),ko=f(Q),x=i(Q,"LI",{});var be=n(x);Ro=l(be,"Wrap the base model with "),He=i(be,"CODE",{});var $r=n(He);Po=l($r,"get_peft_model()"),$r.forEach(a),xo=l(be," to get a trainable "),je=i(be,"CODE",{});var Dr=n(je);To=l(Dr,"PeftModel"),Dr.forEach(a),Co=l(be,"."),be.forEach(a),$o=f(Q),le=i(Q,"LI",{});var ga=n(le);Do=l(ga,"Train the "),Ge=i(ga,"CODE",{});var Or=n(Ge);Oo=l(Or,"PeftModel"),Or.forEach(a),Io=l(ga," as you normally would train the base model."),ga.forEach(a),Q.forEach(a),Xt=f(t),re=i(t,"P",{});var Gl=n(re);Je=i(Gl,"CODE",{});var Ir=n(Je);Mo=l(Ir,"LoraConfig"),Ir.forEach(a),So=l(Gl," allows you to control how LoRA is applied to the base model through the following parameters:"),Gl.forEach(a),Yt=f(t),m=i(t,"UL",{});var u=n(m);B=i(u,"LI",{});var bt=n(B);Ve=i(bt,"CODE",{});var Mr=n(Ve);Uo=l(Mr,"r"),Mr.forEach(a),No=l(bt,": the rank of the update matrices, expressed in "),Ke=i(bt,"CODE",{});var Sr=n(Ke);qo=l(Sr,"int"),Sr.forEach(a),Fo=l(bt,". Lower rank results in smaller update matrices with fewer trainable parameters."),bt.forEach(a),zo=f(u),me=i(u,"LI",{});var Jl=n(me);Qe=i(Jl,"CODE",{});var Ur=n(Qe);Wo=l(Ur,"target_modules"),Ur.forEach(a),Bo=l(Jl,": The modules (for example, attention blocks) to apply the LoRA update matrices."),Jl.forEach(a),Ho=f(u),pe=i(u,"LI",{});var Vl=n(pe);Xe=i(Vl,"CODE",{});var Nr=n(Xe);jo=l(Nr,"alpha"),Nr.forEach(a),Go=l(Vl,": LoRA scaling factor."),Vl.forEach(a),Jo=f(u),g=i(u,"LI",{});var y=n(g);Ye=i(y,"CODE",{});var qr=n(Ye);Vo=l(qr,"bias"),qr.forEach(a),Ko=l(y,": Specifies if the "),Ze=i(y,"CODE",{});var Fr=n(Ze);Qo=l(Fr,"bias"),Fr.forEach(a),Xo=l(y," parameters should be trained. Can be "),et=i(y,"CODE",{});var zr=n(et);Yo=l(zr,"'none'"),zr.forEach(a),Zo=l(y,", "),tt=i(y,"CODE",{});var Wr=n(tt);el=l(Wr,"'all'"),Wr.forEach(a),tl=l(y," or "),at=i(y,"CODE",{});var Br=n(at);al=l(Br,"'lora_only'"),Br.forEach(a),ol=l(y,"."),y.forEach(a),ll=f(u),ue=i(u,"LI",{});var Kl=n(ue);ot=i(Kl,"CODE",{});var Hr=n(ot);rl=l(Hr,"modules_to_save"),Hr.forEach(a),il=l(Kl,": List of modules apart from LoRA layers to be set as trainable and saved in the final checkpoint. These typically include model\u2019s custom head that is randomly initialized for the fine-tuning task."),Kl.forEach(a),nl=f(u),H=i(u,"LI",{});var Et=n(H);lt=i(Et,"CODE",{});var jr=n(lt);sl=l(jr,"layers_to_transform"),jr.forEach(a),dl=l(Et,": List of layers to be transformed by LoRA. If not specified, all layers in "),rt=i(Et,"CODE",{});var Gr=n(rt);hl=l(Gr,"target_modules"),Gr.forEach(a),fl=l(Et," are transformed."),Et.forEach(a),cl=f(u),p=i(u,"LI",{});var _=n(p);it=i(_,"CODE",{});var Jr=n(it);ml=l(Jr,"layers_pattern"),Jr.forEach(a),pl=l(_,": Pattern to match layer names in "),nt=i(_,"CODE",{});var Vr=n(nt);ul=l(Vr,"target_modules"),Vr.forEach(a),_l=l(_,", if "),st=i(_,"CODE",{});var Kr=n(st);vl=l(Kr,"layers_to_transform"),Kr.forEach(a),gl=l(_," is specified. By default "),dt=i(_,"CODE",{});var Qr=n(dt);wl=l(Qr,"PeftModel"),Qr.forEach(a),yl=l(_," will look at common layer pattern ("),ht=i(_,"CODE",{});var Xr=n(ht);bl=l(Xr,"layers"),Xr.forEach(a),El=l(_,", "),ft=i(_,"CODE",{});var Yr=n(ft);Ll=l(Yr,"h"),Yr.forEach(a),Al=l(_,", "),ct=i(_,"CODE",{});var Zr=n(ct);kl=l(Zr,"blocks"),Zr.forEach(a),Rl=l(_,", etc.), use it for exotic and custom models."),_.forEach(a),Pl=f(u),j=i(u,"LI",{});var Lt=n(j);mt=i(Lt,"CODE",{});var ei=n(mt);xl=l(ei,"rank_pattern"),ei.forEach(a),Tl=l(Lt,": The mapping from layer names or regexp expression to ranks which are different from the default rank specified by "),pt=i(Lt,"CODE",{});var ti=n(pt);Cl=l(ti,"r"),ti.forEach(a),$l=l(Lt,"."),Lt.forEach(a),Dl=f(u),G=i(u,"LI",{});var At=n(G);ut=i(At,"CODE",{});var ai=n(ut);Ol=l(ai,"alpha_pattern"),ai.forEach(a),Il=l(At,": The mapping from layer names or regexp expression to alphas which are different from the default alpha specified by "),_t=i(At,"CODE",{});var oi=n(_t);Ml=l(oi,"lora_alpha"),oi.forEach(a),Sl=l(At,"."),At.forEach(a),u.forEach(a),Zt=f(t),T=i(t,"H2",{class:!0});var wa=n(T);J=i(wa,"A",{id:!0,class:!0,href:!0});var li=n(J);vt=i(li,"SPAN",{});var ri=n(vt);Rt(ie.$$.fragment,ri),ri.forEach(a),li.forEach(a),Ul=f(wa),gt=i(wa,"SPAN",{});var ii=n(gt);Nl=l(ii,"LoRA examples"),ii.forEach(a),wa.forEach(a),ea=f(t),_e=i(t,"P",{});var ni=n(_e);ql=l(ni,"For an example of LoRA method application to various downstream tasks, please refer to the following guides:"),ni.forEach(a),ta=f(t),V=i(t,"UL",{});var ya=n(V);wt=i(ya,"LI",{});var si=n(wt);ve=i(si,"A",{href:!0});var di=n(ve);Fl=l(di,"Image classification using LoRA"),di.forEach(a),si.forEach(a),zl=f(ya),yt=i(ya,"LI",{});var hi=n(yt);ge=i(hi,"A",{href:!0});var fi=n(ge);Wl=l(fi,"Semantic segmentation"),fi.forEach(a),hi.forEach(a),ya.forEach(a),aa=f(t),K=i(t,"P",{});var ba=n(K);Bl=l(ba,`While the original paper focuses on language models, the technique can be applied to any dense layers in deep learning
models. As such, you can leverage this technique with diffusion models. See `),we=i(ba,"A",{href:!0});var ci=n(we);Hl=l(ci,"Dreambooth fine-tuning with LoRA"),ci.forEach(a),jl=l(ba," task guide for an example."),ba.forEach(a),this.h()},h(){c(L,"name","hf:doc:metadata"),c(L,"content",JSON.stringify(bi)),c(C,"id","lora"),c(C,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(C,"href","#lora"),c(A,"class","relative group"),c(Y,"href","https://arxiv.org/abs/2106.09685"),c(Y,"rel","nofollow"),c(I,"id","merge-lora-weights-into-the-base-model"),c(I,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(I,"href","#merge-lora-weights-into-the-base-model"),c(k,"class","relative group"),c(se,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.merge_and_unload"),vi(Oe.src,Xl="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/peft/lora_diagram.png")||c(Oe,"src",Xl),c(ee,"class","flex justify-center"),c(S,"id","utils-for-lora"),c(S,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(S,"href","#utils-for-lora"),c(R,"class","relative group"),c(de,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.unload"),c(he,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.delete_adapter"),c(fe,"href","/docs/peft/main/en/package_reference/tuners#peft.LoraModel.add_weighted_adapter"),c(W,"id","common-lora-parameters-in-peft"),c(W,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(W,"href","#common-lora-parameters-in-peft"),c(P,"class","relative group"),c(J,"id","lora-examples"),c(J,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),c(J,"href","#lora-examples"),c(T,"class","relative group"),c(ve,"href","../task_guides/image_classification_lora"),c(ge,"href","../task_guides/semantic_segmentation_lora"),c(we,"href","../task_guides/task_guides/dreambooth_lora")},m(t,s){e(document.head,L),d(t,Dt,s),d(t,A,s),e(A,C),e(C,Ee),Pt(X,Ee,null),e(A,Ea),e(A,Le),e(Le,La),d(t,Ot,s),d(t,$,s),e($,Aa),e($,Y),e(Y,ka),e($,Ra),d(t,It,s),d(t,D,s),e(D,Pa),e(D,Ae),e(Ae,xa),e(D,Ta),d(t,Mt,s),d(t,ne,s),e(ne,Ca),d(t,St,s),d(t,v,s),e(v,ke),e(ke,$a),e(v,Da),e(v,Re),e(Re,Oa),e(v,Ia),e(v,Pe),e(Pe,Ma),e(v,Sa),e(v,xe),e(xe,Ua),e(v,Na),e(v,Te),e(Te,qa),d(t,Ut,s),d(t,O,s),e(O,Fa),e(O,Ce),e(Ce,za),e(O,Wa),d(t,Nt,s),d(t,k,s),e(k,I),e(I,$e),Pt(Z,$e,null),e(k,Ba),e(k,De),e(De,Ha),d(t,qt,s),d(t,M,s),e(M,ja),e(M,se),e(se,Ga),e(M,Ja),d(t,Ft,s),d(t,ee,s),e(ee,Oe),d(t,zt,s),d(t,b,s),e(b,Va),e(b,Ie),e(Ie,Ka),e(b,Qa),e(b,Me),e(Me,Xa),e(b,Ya),d(t,Wt,s),d(t,R,s),e(R,S),e(S,Se),Pt(te,Se,null),e(R,Za),e(R,Ue),e(Ue,eo),d(t,Bt,s),d(t,U,s),e(U,to),e(U,Ne),e(Ne,ao),e(U,oo),d(t,Ht,s),d(t,N,s),e(N,lo),e(N,qe),e(qe,ro),e(N,io),d(t,jt,s),d(t,q,s),e(q,no),e(q,de),e(de,so),e(q,ho),d(t,Gt,s),d(t,F,s),e(F,fo),e(F,he),e(he,co),e(F,mo),d(t,Jt,s),d(t,z,s),e(z,po),e(z,fe),e(fe,uo),e(z,_o),d(t,Vt,s),d(t,P,s),e(P,W),e(W,Fe),Pt(ae,Fe,null),e(P,vo),e(P,ze),e(ze,go),d(t,Kt,s),d(t,ce,s),e(ce,wo),d(t,Qt,s),d(t,w,s),e(w,We),e(We,yo),e(w,bo),e(w,oe),e(oe,Eo),e(oe,Be),e(Be,Lo),e(oe,Ao),e(w,ko),e(w,x),e(x,Ro),e(x,He),e(He,Po),e(x,xo),e(x,je),e(je,To),e(x,Co),e(w,$o),e(w,le),e(le,Do),e(le,Ge),e(Ge,Oo),e(le,Io),d(t,Xt,s),d(t,re,s),e(re,Je),e(Je,Mo),e(re,So),d(t,Yt,s),d(t,m,s),e(m,B),e(B,Ve),e(Ve,Uo),e(B,No),e(B,Ke),e(Ke,qo),e(B,Fo),e(m,zo),e(m,me),e(me,Qe),e(Qe,Wo),e(me,Bo),e(m,Ho),e(m,pe),e(pe,Xe),e(Xe,jo),e(pe,Go),e(m,Jo),e(m,g),e(g,Ye),e(Ye,Vo),e(g,Ko),e(g,Ze),e(Ze,Qo),e(g,Xo),e(g,et),e(et,Yo),e(g,Zo),e(g,tt),e(tt,el),e(g,tl),e(g,at),e(at,al),e(g,ol),e(m,ll),e(m,ue),e(ue,ot),e(ot,rl),e(ue,il),e(m,nl),e(m,H),e(H,lt),e(lt,sl),e(H,dl),e(H,rt),e(rt,hl),e(H,fl),e(m,cl),e(m,p),e(p,it),e(it,ml),e(p,pl),e(p,nt),e(nt,ul),e(p,_l),e(p,st),e(st,vl),e(p,gl),e(p,dt),e(dt,wl),e(p,yl),e(p,ht),e(ht,bl),e(p,El),e(p,ft),e(ft,Ll),e(p,Al),e(p,ct),e(ct,kl),e(p,Rl),e(m,Pl),e(m,j),e(j,mt),e(mt,xl),e(j,Tl),e(j,pt),e(pt,Cl),e(j,$l),e(m,Dl),e(m,G),e(G,ut),e(ut,Ol),e(G,Il),e(G,_t),e(_t,Ml),e(G,Sl),d(t,Zt,s),d(t,T,s),e(T,J),e(J,vt),Pt(ie,vt,null),e(T,Ul),e(T,gt),e(gt,Nl),d(t,ea,s),d(t,_e,s),e(_e,ql),d(t,ta,s),d(t,V,s),e(V,wt),e(wt,ve),e(ve,Fl),e(V,zl),e(V,yt),e(yt,ge),e(ge,Wl),d(t,aa,s),d(t,K,s),e(K,Bl),e(K,we),e(we,Hl),e(K,jl),oa=!0},p:gi,i(t){oa||(xt(X.$$.fragment,t),xt(Z.$$.fragment,t),xt(te.$$.fragment,t),xt(ae.$$.fragment,t),xt(ie.$$.fragment,t),oa=!0)},o(t){Tt(X.$$.fragment,t),Tt(Z.$$.fragment,t),Tt(te.$$.fragment,t),Tt(ae.$$.fragment,t),Tt(ie.$$.fragment,t),oa=!1},d(t){a(L),t&&a(Dt),t&&a(A),Ct(X),t&&a(Ot),t&&a($),t&&a(It),t&&a(D),t&&a(Mt),t&&a(ne),t&&a(St),t&&a(v),t&&a(Ut),t&&a(O),t&&a(Nt),t&&a(k),Ct(Z),t&&a(qt),t&&a(M),t&&a(Ft),t&&a(ee),t&&a(zt),t&&a(b),t&&a(Wt),t&&a(R),Ct(te),t&&a(Bt),t&&a(U),t&&a(Ht),t&&a(N),t&&a(jt),t&&a(q),t&&a(Gt),t&&a(F),t&&a(Jt),t&&a(z),t&&a(Vt),t&&a(P),Ct(ae),t&&a(Kt),t&&a(ce),t&&a(Qt),t&&a(w),t&&a(Xt),t&&a(re),t&&a(Yt),t&&a(m),t&&a(Zt),t&&a(T),Ct(ie),t&&a(ea),t&&a(_e),t&&a(ta),t&&a(V),t&&a(aa),t&&a(K)}}}const bi={local:"lora",sections:[{local:"merge-lora-weights-into-the-base-model",title:"Merge LoRA weights into the base model"},{local:"utils-for-lora",title:"Utils for LoRA"},{local:"common-lora-parameters-in-peft",title:"Common LoRA parameters in PEFT"},{local:"lora-examples",title:"LoRA examples"}],title:"LoRA "};function Ei(Ql){return wi(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ki extends mi{constructor(L){super();pi(this,L,Ei,yi,ui,{})}}export{ki as default,bi as metadata};
